package org.fouram.core.plugin.weixin.cp.util;

import org.fouram.core.plugin.weixin.cp.core.WXCpMessage;
import org.fouram.core.util.LoggerUtil;

import me.chanjar.weixin.common.api.WxConsts.KefuMsgType;
import me.chanjar.weixin.common.error.WxErrorException;
import me.chanjar.weixin.cp.bean.WxCpMessage;
import me.chanjar.weixin.cp.bean.WxCpMessageSendResult;

/**
 * 企业微信用户工具类
 * 
 * @author Liup
 */
public class WXCpMessageUtil {

	public static void send(String content, String toUser) throws WxErrorException {
		try {
			WxCpMessage message = new WxCpMessage();
			message.setToUser(toUser);
			message.setMsgType(KefuMsgType.TEXT);
			message.setContent(content);
			WxCpMessageSendResult sendResult = WXCpMessage.service.messageSend(message);
			LoggerUtil.info(sendResult.toString());
		} catch (WxErrorException e) {
			LoggerUtil.error(e);
		}
	}

	public static void main(String[] args) throws WxErrorException {
		StringBuffer sb = new StringBuffer();
		sb.append("有一个新员工入职，待同步企业微信").append("\n").append("员工姓名：").append("张三")
		.append("\n").append("手机号：").append("138XXXXXXXX")
		.append("\n").append("邮箱：").append("138XXXXXXXX@")
		.append("\n").append("<a href=\"http://www.baidu.com\"><a href=\"http://www.baidu.com\">立即同步</a></a>");
		send(sb.toString(), "1000001");
	}
}
