package org.fouram.job;

import java.util.List;

import org.fouram.core.util.LoggerUtil;
import org.fouram.entity.SapMessageUser;
import org.fouram.entity.SapUser;
import org.fouram.service.SapMessageUserService;
import org.fouram.service.SapUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class MessageJob {

	@Autowired
	private SapUserService sapUserService;
	@Autowired
	private SapMessageUserService sapMessageUserService;

	public void taskBiz() {
		try {
			List<SapMessageUser> messageUsers = sapMessageUserService.selectList();
			List<SapUser> sapUsers = sapUserService.selectNotSendEntryMessageList();
			StringBuffer messageContent = null;
			for (SapUser sapUser : sapUsers) {
				messageContent = new StringBuffer();
				messageContent.append("有一个新员工入职，待同步企业微信").append("\n").append("员工姓名：").append(sapUser.getName())
						.append("\n").append("手机号：").append(sapUser.getFormatMobile()).append("\n").append("邮箱：")
						.append(sapUser.getRealEmail()).append("\n").append(getSyncUrl());
				sapUserService.sendEntryMessage(messageContent.toString(), sapUser, messageUsers);
			}
		} catch (Exception e) {
			LoggerUtil.error(e);
		}
	}

	private static String getSyncUrl() {
		String syncUrl = "https://studybom.suggest.vip/#/userSync/list";
		return String.format("<a href=\"%s\"><a href=\"%s\">立即同步</a></a>", syncUrl, syncUrl);
	}
}
