package org.fouram.service;

import java.util.List;

import org.fouram.core.base.model.PageData;
import org.fouram.core.base.service.BaseService;
import org.fouram.core.util.ResultUtil;
import org.fouram.entity.SapMessageUser;
import org.springframework.stereotype.Service;

@Service
public class SapMessageUserService extends BaseService {
	
	@SuppressWarnings("unchecked")
	public List<SapMessageUser> selectList() throws Exception {
		return (List<SapMessageUser>) findList("SapMessageUserMapper.selectList", null);
	}

	public PageData saveOne(String userId) throws Exception {
		SapMessageUser entity = selectByUserId(userId);
		if(entity != null) {
			return ResultUtil.error("该用户已保存");
		}
		entity = SapMessageUser.builder().userId(userId).build();
		save("SapMessageUserMapper.saveOne", entity);
		return ResultUtil.success();
	}

	public SapMessageUser selectByUserId(String userId) throws Exception {
		return (SapMessageUser) findObject("SapMessageUserMapper.selectByUserId", userId);
	}

	public void deleteById(String id) throws Exception {
		update("SapMessageUserMapper.deleteById", id);
	}
}
